Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 2247)
+++ inc/admin/prepend.php	(revision 2229)
@@ -262,5 +262,5 @@
 	$_menu['Blog']->prependItem(__('New entry'),'post.php','images/menu/edit.png',
 		preg_match('/post.php$/',$_SERVER['REQUEST_URI']),
-		$core->auth->check('usage,contentadmin',$core->blog->id));
+		$core->auth->check('usage,contentadmin',$core->blog->id),'menu-new-post');
 	
 	$_menu['System']->prependItem(__('Update'),'update.php','images/menu/update.png',
Index: inc/core/class.dc.modules.php
===================================================================
--- inc/core/class.dc.modules.php	(revision 2245)
+++ inc/core/class.dc.modules.php	(revision 2239)
@@ -244,5 +244,5 @@
 	{
 		$zip = new fileUnzip($zip_file);
-		$zip->getList(false,'#(^|/)(__MACOSX|\.svn|\.hg|\.git|\.DS_Store|\.directory|Thumbs\.db)(/|$)#');
+		$zip->getList(false,'#(^|/)(__MACOSX|\.svn|\.DS_Store|\.directory|Thumbs\.db)(/|$)#');
 		
 		$zip_root_dir = $zip->getRootDir();
Index: inc/core/class.dc.store.parser.php
===================================================================
--- inc/core/class.dc.store.parser.php	(revision 2222)
+++ inc/core/class.dc.store.parser.php	(revision 2222)
@@ -0,0 +1,106 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+/**
+@ingroup DC_CORE
+@brief Repository modules XML feed parser
+@since 2.6
+
+Provides an object to parse XML feed of modules from a repository.
+*/
+class dcStoreParser
+{
+	/** @var	object	XML object of feed contents */
+	protected $xml;
+	/** @var	array	Array of feed contents */
+	protected $items;
+	/** @var	string	XML bloc tag */
+	protected static $bloc = 'http://dotaddict.org/da/';
+
+	/**
+	 * Constructor.
+	 *
+	 * @param	string	$data		Feed content
+	 */
+	public function __construct($data)
+	{
+		if (!is_string($data)) {
+			throw new Exception(__('Failed to read data feed'));
+		}
+
+		$this->xml = simplexml_load_string($data);
+		$this->items = array();
+
+		if ($this->xml === false) {
+			throw new Exception(__('Wrong data feed'));
+		}
+
+		$this->_parse();
+
+		unset($data);
+		unset($this->xml);
+	}
+
+	/**
+	 * Parse XML into array
+	 */
+	protected function _parse()
+	{
+		if (empty($this->xml->module)) {
+			return;
+		}
+
+		foreach ($this->xml->module as $i) {
+			$attrs = $i->attributes();
+
+			$item = array();
+
+			# DC/DA shared markers
+			$item['id']		= (string) $attrs['id'];
+			$item['file']		= (string) $i->file;
+			$item['label']		= (string) $i->name; // deprecated
+			$item['name']		= (string) $i->name;
+			$item['version']	= (string) $i->version;
+			$item['author']	= (string) $i->author;
+			$item['desc']		= (string) $i->desc;
+
+			# DA specific markers
+			$item['dc_min'] 	= (string) $i->children(self::$bloc)->dcmin;
+			$item['details'] 	= (string) $i->children(self::$bloc)->details;
+			$item['section'] 	= (string) $i->children(self::$bloc)->section;
+			$item['support'] 	= (string) $i->children(self::$bloc)->support;
+			$item['sshot']		= (string) $i->children(self::$bloc)->sshot;
+
+			$tags = array();
+			foreach($i->children(self::$bloc)->tags as $t) {
+				$tags[] = (string) $t->tag;
+			}
+			$item['tags']		= implode(', ',$tags);
+			
+			# First filter right now. If DC_DEV is set all modules are parse
+			if (defined('DC_DEV') && DC_DEV === true || version_compare(DC_VERSION,$item['dc_min'],'>=')) {
+				$this->items[$item['id']] = $item;
+			}
+		}
+	}
+
+	/**
+	 * Get modules.
+	 *
+	 * @return	array		Modules list
+	 */
+	public function getModules()
+	{
+		return $this->items;
+	}
+}
Index: inc/core/class.dc.store.php
===================================================================
--- inc/core/class.dc.store.php	(revision 2222)
+++ inc/core/class.dc.store.php	(revision 2222)
@@ -0,0 +1,287 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+/**
+@ingroup DC_CORE
+@brief Repository modules XML feed reader
+@since 2.6
+
+Provides an object to parse XML feed of modules from repository.
+*/
+class dcStore
+{
+	/** @var	object	dcCore instance */
+	public $core;
+	/** @var	object	dcModules instance */
+	public $modules;
+
+	/** @var	array	Modules fields to search on and their weighting */
+	public static $weighting = array('id' => 10, 'name' => 8, 'author' => 6, 'tags' => 4, 'desc' => 2);
+
+	/** @var	string	User agent used to query repository */
+	protected $user_agent = 'DotClear.org RepoBrowser/0.1';
+	/** @var	string	XML feed URL */
+	protected $xml_url;
+	/** @var	array	Array of new/update modules from repository */
+	protected $data;
+
+	/**
+	 * Constructor.
+	 *
+	 * @param	object	$modules		dcModules instance
+	 * @param	string	$xml_url		XML feed URL
+	 */
+	public function __construct(dcModules $modules, $xml_url)
+	{
+		$this->core = $modules->core;
+		$this->modules = $modules;
+		$this->xml_url = $xml_url;
+		$this->user_agent = sprintf('Dotclear/%s)', DC_VERSION);
+
+		$this->check();
+	}
+
+	/**
+	 * Check repository.
+	 *
+	 * @param	boolean	$force		Force query repository
+	 * @return	boolean	True if get feed or cache
+	 */
+	public function check($force=false)
+	{
+		if (!$this->xml_url) {
+			return false;
+		}
+		if (($parser = dcStoreReader::quickParse($this->xml_url, DC_TPL_CACHE, $force)) === false) {
+			return false;
+		}
+
+		$raw_datas = $parser->getModules();
+
+		uasort($raw_datas, array('self','sort'));
+
+		$skipped = array_keys($this->modules->getDisabledModules());
+		foreach ($skipped as $p_id) {
+			if (isset($raw_datas[$p_id])) {
+				unset($raw_datas[$p_id]);
+			}
+		}
+
+		$updates = array();
+		$current = $this->modules->getModules();
+		foreach ($current as $p_id => $p_infos) {
+			if (isset($raw_datas[$p_id])) {
+				if (self::compare($raw_datas[$p_id]['version'],$p_infos['version'],'>')) {
+					$updates[$p_id] = $raw_datas[$p_id];
+					$updates[$p_id]['root'] = $p_infos['root'];
+					$updates[$p_id]['root_writable'] = $p_infos['root_writable'];
+					$updates[$p_id]['current_version'] = $p_infos['version'];
+				}
+				unset($raw_datas[$p_id]);
+			}
+		}
+
+		$this->data = array(
+			'new'	=> $raw_datas,
+			'update'	=> $updates
+		);
+
+		return true;
+	}
+
+	/**
+	 * Get a list of modules.
+	 *
+	 * @param	boolean	$update	True to get update modules, false for new ones
+	 * @return	array	List of update/new modules
+	 */
+	public function get($update=false)
+	{
+		return $this->data[$update ? 'update' : 'new'];
+	}
+
+	/**
+	 * Search a module.
+	 *
+	 * Search string is cleaned, split and compare to split:
+	 * - module id and clean id,
+	 * - module name, clean name,
+	 * - module desccription.
+	 *
+	 * Every time a part of query is find on module,
+	 * result accuracy grow. Result is sorted by accuracy.
+	 *
+	 * @param	string	$pattern	String to search
+	 * @return	array	Match modules
+	 */
+	public function search($pattern)
+	{
+		$result = array();
+
+		# Split query into small clean words
+		if (!($patterns = self::patternize($pattern))) {
+			return $result;
+		}
+
+		# For each modules
+		foreach ($this->data['new'] as $id => $module) {
+			$module['id'] = $id;
+
+			# Loop through required module fields
+			foreach(self::$weighting as $field => $weight) {
+
+				# Skip fields which not exsist on module
+				if (empty($module[$field])) {
+					continue;
+				}
+
+				# Split field value into small clean word
+				if (!($subjects = self::patternize($module[$field]))) {
+					continue;
+				}
+
+				# Check contents
+				if (!($nb = preg_match_all('/('.implode('|', $patterns).')/', implode(' ', $subjects), $_))) {
+					continue;
+				}
+
+				# Add module to result
+				if (!isset($sorter[$id])) {
+					$sorter[$id] = 0;
+					$result[$id] = $module;
+				}
+
+				# Increment score by matches count * field weight
+				$sorter[$id] += $nb * $weight;
+				$result[$id]['score'] = $sorter[$id];
+			}
+		}
+		# Sort response by matches count
+		if (!empty($result)) {
+			array_multisort($sorter, SORT_DESC, $result);
+		}
+		return $result;
+	}
+
+	/**
+	 * Quick download and install module.
+	 *
+	 * @param	string	$url	Module package URL
+	 * @param	string	$dest	Path to install module
+	 * @return	integer		1 = installed, 2 = update
+	 */
+	public function process($url, $dest)
+	{
+		$this->download($url, $dest);
+		return $this->install($dest);
+	}
+
+	/**
+	 * Download a module.
+	 *
+	 * @param	string	$url	Module package URL
+	 * @param	string	$dest	Path to put module package
+	 */
+	public function download($url, $dest)
+	{
+		try {
+			$client = netHttp::initClient($url, $path);
+			$client->setUserAgent(self::agent());
+			$client->useGzip(false);
+			$client->setPersistReferers(false);
+			$client->setOutput($dest);
+			$client->get($path);
+			unset($client);
+		}
+		catch (Exception $e) {
+			unset($client);
+			throw new Exception(__('An error occurred while downloading the file.'));
+		}
+	}
+
+	/**
+	 * Install a previously downloaded module.
+	 *
+	 * @param	string	$path	Module package URL
+	 * @param	string	$path	Path to module package
+	 * @return	integer		1 = installed, 2 = update
+	 */
+	public function install($path)
+	{
+		return dcModules::installPackage($path, $this->modules);
+	}
+
+	/**
+	 * User Agent String.
+	 *
+	 * @param	string	$str		User agent string
+	 */
+	public function agent($str)
+	{
+		$this->user_agent = $str;
+	}
+
+	/**
+	 * Split and clean pattern.
+	 *
+	 * @param	string	$str		String to sanitize
+	 * @return	array	Array of cleaned pieces of string or false if none
+	 */
+	public static function patternize($str)
+	{
+		$arr = array();
+
+		foreach(explode(' ', $str) as $_) {
+			$_ = strtolower(preg_replace('/[^A-Za-z0-9]/', '', $_));
+			if (strlen($_) > 2) {
+				$arr[] = $_;
+			}
+		}
+
+		return empty($arr) ? false : $arr;
+	}
+
+	/**
+	 * Compare version.
+	 *
+	 * @param	string	$v1		Version
+	 * @param	string	$v2		Version
+	 * @param	string	$op		Comparison operator
+	 * @return	boolean	True is comparison is true, dude!
+	 */
+	private static function compare($v1, $v2, $op)
+	{
+		return version_compare(
+			preg_replace('!-r(\d+)$!', '-p$1', $v1), 
+			preg_replace('!-r(\d+)$!', '-p$1', $v2), 
+			$op
+		);
+	}
+
+	/** 
+	 * Sort modules list.
+	 *
+	 * @param	array	$a		A module
+	 * @param	array	$b		A module
+	 * @return	integer
+	 */
+	private static function sort($a,$b)
+	{
+		$c = strtolower($a['id']); 
+		$d = strtolower($b['id']); 
+		if ($c == $d) { 
+			return 0; 
+		} 
+		return ($c < $d) ? -1 : 1; 
+	}
+}
Index: inc/core/class.dc.store.reader.php
===================================================================
--- inc/core/class.dc.store.reader.php	(revision 2222)
+++ inc/core/class.dc.store.reader.php	(revision 2222)
@@ -0,0 +1,267 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+/**
+@ingroup DC_CORE
+@brief Repository modules XML feed reader
+@since 2.6
+
+Provides an object to parse XML feed of modules from repository.
+This class extends clearbricks netHttp class.
+*/
+class dcStoreReader extends netHttp
+{
+	/** @var	string	User agent used to query repository */
+	protected $user_agent = 'DotClear.org RepoBrowser/0.1';
+	/** @var	integer	User agent used to query repository */
+	protected $timeout = 5;
+	/** @var	array	 HTTP Cache validators */
+	protected $validators = null;
+	/** @var	string	Cache temporary directory */
+	protected $cache_dir = null;
+	/** @var	string	Cache file prefix */
+	protected $cache_file_prefix = 'dcrepo';
+	/** @var	integer	Cache TTL */
+	protected $cache_ttl = '-30 minutes';
+	/** @var	boolean	'Cache' TTL on server failed */
+	protected $cache_touch_on_fail = true;
+	/** @var	boolean	Force query server */
+	protected $force = false;
+
+	/**
+	 * Constructor.
+	 *
+	 * Bypass first argument of clearbricks netHttp constructor.
+	 */
+	public function __construct()
+	{
+		parent::__construct('');
+		$this->setUserAgent(sprintf('Dotclear/%s)', DC_VERSION));
+	}
+
+	/**
+	 * Parse modules feed.
+	 *
+	 * @param	string	$url		XML feed URL
+	 * @return	object	dcStore instance
+	 */
+	public function parse($url)
+	{
+		$this->validators = array();
+
+		if ($this->cache_dir) {
+			return $this->withCache($url);
+		}
+		elseif (!$this->getModulesXML($url) || $this->getStatus() != '200') {
+			return false;
+		}
+
+		return new dcStoreParser($this->getContent());
+	}
+
+	/**
+	 * Quick parse modules feed.
+	 *
+	 * @param	string	$url		XML feed URL
+	 * @param	string	$cache_dir	Cache directoy or null for no cache
+	 * @param	boolean	$force		Force query repository
+	 * @return	object	Self instance
+	 */
+	public static function quickParse($url, $cache_dir=null, $force=false)
+	{
+		$parser = new self();
+		if ($cache_dir) {
+			$parser->setCacheDir($cache_dir);
+		}
+		if ($force) {
+			$parser->setForce($force);
+		}
+
+		return $parser->parse($url);
+	}
+
+	/**
+	 * Set cache directory.
+	 *
+	 * @param	string	$dir		Cache directory
+	 * @return	boolean	True if cache dierctory is useable
+	 */
+	public function setCacheDir($dir)
+	{
+		$this->cache_dir = null;
+
+		if (!empty($dir) && is_dir($dir) && is_writeable($dir)) {
+			$this->cache_dir = $dir;
+			return true;
+		}
+
+		return false;
+	}
+
+	/**
+	 * Set cache TTL.
+	 *
+	 * @param	string	$str		Cache TTL
+	 */
+	public function setCacheTTL($str)
+	{
+		$str = trim($str);
+
+		if (!empty($str)) {
+			$this->cache_ttl = substr($str, 0, 1) == '-' ? $str : '-'.$str;
+		}
+	}
+
+	/**
+	 * Set force query repository.
+	 *
+	 * @param	boolean	$force	True to force query
+	 */
+	public function setForce($force)
+	{
+		$this->force = $force;
+	}
+
+	/**
+	 * Get repository XML feed URL content.
+	 *
+	 * @param	string	$url		XML feed URL
+	 * @return	string	Feed content
+	 */
+	protected function getModulesXML($url)
+	{
+		if (!self::readURL($url, $ssl, $host, $port, $path, $user, $pass)) {
+			return false;
+		}
+		$this->setHost($host, $port);
+		$this->useSSL($ssl);
+		$this->setAuthorization($user, $pass);
+
+		return $this->get($path);
+	}
+
+	/**
+	 * Get repository modules list using cache.
+	 *
+	 * @param	string	$url		XML feed URL
+	 * @return	array	Feed content or False on fail
+	 */
+	protected function withCache($url)
+	{
+		$url_md5 = md5($url);
+		$cached_file = sprintf('%s/%s/%s/%s/%s.ser',
+			$this->cache_dir,
+			$this->cache_file_prefix,
+			substr($url_md5,0,2),
+			substr($url_md5,2,2),
+			$url_md5
+		);
+
+		$may_use_cached = false;
+
+		# Use cache file ?
+		if (@file_exists($cached_file) && !$this->force) {
+			$may_use_cached = true;
+			$ts = @filemtime($cached_file);
+			if ($ts > strtotime($this->cache_ttl)) {
+				# Direct cache
+				return unserialize(file_get_contents($cached_file));
+			}
+			$this->setValidator('IfModifiedSince', $ts);
+		}
+
+		# Query repository
+		if (!$this->getModulesXML($url)) {
+			if ($may_use_cached) {
+				# Touch cache TTL even if query failed ?
+				if ($this->cache_touch_on_fail) {
+					@files::touch($cached_file);
+				}
+				# Connection failed - fetched from cache
+				return unserialize(file_get_contents($cached_file));
+			}
+			return false;
+		}
+
+		# Parse response
+		switch ($this->getStatus())
+		{
+			# Not modified, use cache
+			case '304':
+				@files::touch($cached_file);
+				return unserialize(file_get_contents($cached_file));
+			# Ok, parse feed
+			case '200':
+				if ($modules = new dcStoreParser($this->getContent())) {
+					try {
+						files::makeDir(dirname($cached_file), true);
+					}
+					catch (Exception $e) {
+						return $modules;
+					}
+
+					if (($fp = @fopen($cached_file, 'wb'))) {
+						fwrite($fp, serialize($modules));
+						fclose($fp);
+						files::inheritChmod($cached_file);
+					}
+					return $modules;
+				}
+		}
+
+		return false;
+	}
+
+	/**
+	 * Prepare query.
+	 *
+	 * @return	array	Query headers
+	 */
+	protected function buildRequest()
+	{
+		$headers = parent::buildRequest();
+
+		# Cache validators
+		if (!empty($this->validators)) {
+			if (isset($this->validators['IfModifiedSince'])) {
+				$headers[] = 'If-Modified-Since: '.$this->validators['IfModifiedSince'];
+			}
+			if (isset($this->validators['IfNoneMatch'])) {
+				if (is_array($this->validators['IfNoneMatch'])) {
+					$etags = implode(',', $this->validators['IfNoneMatch']);
+				}
+				else {
+					$etags = $this->validators['IfNoneMatch'];
+				}
+				$headers[] = '';
+			}
+		}
+
+		return $headers;
+	}
+
+	/**
+	 * Tweak query cache validator.
+	 *
+	 * @param	string	$key		Validator key
+	 * @param	string	$value		Validator value
+	 */
+	private function setValidator($key, $value)
+	{
+		if ($key == 'IfModifiedSince') {
+			$value = gmdate('D, d M Y H:i:s', $value).' GMT';
+		}
+
+		$this->validators[$key] = $value;
+	}
+}
Index: inc/dbschema/upgrade.php
===================================================================
--- inc/dbschema/upgrade.php	(revision 2247)
+++ inc/dbschema/upgrade.php	(revision 2144)
@@ -152,5 +152,5 @@
 				$init_fav['new_post'] = array('new_post','New entry','post.php',
 					'images/menu/edit.png','images/menu/edit-b.png',
-					'usage,contentadmin',null,null);
+					'usage,contentadmin',null,'menu-new-post');
 				$init_fav['newpage'] = array('newpage','New page','plugin.php?p=pages&amp;act=page',
 					'index.php?pf=pages/icon-np.png','index.php?pf=pages/icon-np-big.png',
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2236)
+++ inc/prepend.php	(revision 2240)
@@ -46,4 +46,7 @@
 $__autoload['dcWorkspace']			= dirname(__FILE__).'/core/class.dc.workspace.php';
 $__autoload['dcPrefs']				= dirname(__FILE__).'/core/class.dc.prefs.php';
+$__autoload['dcStore']			= dirname(__FILE__).'/core/class.dc.store.php';
+$__autoload['dcStoreReader']		= dirname(__FILE__).'/core/class.dc.store.reader.php';
+$__autoload['dcStoreParser']		= dirname(__FILE__).'/core/class.dc.store.parser.php';
 $__autoload['dcFavorites']			= dirname(__FILE__).'/admin/class.dc.favorites.php';
 
@@ -62,4 +65,6 @@
 $__autoload['dcPager']		= dirname(__FILE__).'/admin/lib.pager.php';
 $__autoload['dcAdminCombos']			= dirname(__FILE__).'/admin/lib.admincombos.php';
+$__autoload['adminModulesList']			= dirname(__FILE__).'/admin/lib.moduleslist.php';
+$__autoload['adminThemesList']			= dirname(__FILE__).'/admin/lib.moduleslist.php';
 
 $__autoload['dcTemplate']			= dirname(__FILE__).'/public/class.dc.template.php';
Index: plugins/aboutConfig/_define.php
===================================================================
--- plugins/aboutConfig/_define.php	(revision 2257)
+++ plugins/aboutConfig/_define.php	(revision 1179)
@@ -16,9 +16,5 @@
 	/* Description*/		"Manage every blog configuration directive",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'0.5',
-	array(
-		'type'		=>		'plugin'
-	)
-
+	/* Version */			'0.5'
 );
 ?>
Index: plugins/aboutConfig/index.php
===================================================================
--- plugins/aboutConfig/index.php	(revision 2256)
+++ plugins/aboutConfig/index.php	(revision 2166)
@@ -37,7 +37,6 @@
 			$core->blog->triggerBlog();
 		}
-
-		dcPage::addSuccessNotice(__('Configuration successfully updated'));
-		http::redirect($p_url);
+		
+		http::redirect($p_url.'&upd=1');
 	}
 	catch (Exception $e)
@@ -63,6 +62,5 @@
 		}
 		
-		dcPage::addSuccessNotice(__('Configuration successfully updated'));
-		http::redirect($p_url.'&part=global');
+		http::redirect($p_url.'&upd=1&part=global');
 	}
 	catch (Exception $e)
@@ -77,8 +75,8 @@
 {
 	if ($s['type'] == 'boolean') {
-		$field = form::combo(array($field_name.'['.$ns.']['.$id.']',$field_name.'_'.$ns.'_'.$id),
+		$field = form::combo(array($field_name.'['.$ns.']['.$id.']',$field_name.'_'.$id),
 		array(__('yes') => 1, __('no') => 0),$s['value'] ? 1 : 0);
 	} else {
-		$field = form::field(array($field_name.'['.$ns.']['.$id.']',$field_name.'_'.$ns.'_'.$id),40,null,
+		$field = form::field(array($field_name.'['.$ns.']['.$id.']',$field_name.'_'.$id),40,null,
 		html::escapeHTML($s['value']));
 	}
@@ -88,5 +86,5 @@
 	return
 	'<tr class="line">'.
-	'<td scope="row"><label for="'.$field_name.'_'.$ns.'_'.$id.'">'.sprintf($slabel,html::escapeHTML($id)).'</label></td>'.
+	'<td scope="row"><label for="s_'.$id.'">'.sprintf($slabel,html::escapeHTML($id)).'</label></td>'.
 	'<td>'.$field.'</td>'.
 	'<td>'.$s['type'].'</td>'.
@@ -122,6 +120,12 @@
 		html::escapeHTML($core->blog->name) => '',
 		__('about:config') => ''
-	)).
-	dcPage::notices();
+	));
+if (!empty($_GET['upd'])) {
+	dcPage::success(__('Configuration successfully updated'));
+}
+
+if (!empty($_GET['upda'])) {
+	dcPage::success(__('Settings definition successfully updated'));
+}
 ?>
 
Index: plugins/akismet/_define.php
===================================================================
--- plugins/akismet/_define.php	(revision 2257)
+++ plugins/akismet/_define.php	(revision 1179)
@@ -19,6 +19,5 @@
 	array(
 		'permissions' =>	'usage,contentadmin',
-		'priority' =>		200,
-		'type'		=>		'plugin'
+		'priority' =>		200
 	)
 );
Index: plugins/antispam/index.php
===================================================================
--- plugins/antispam/index.php	(revision 2256)
+++ plugins/antispam/index.php	(revision 2166)
@@ -43,7 +43,5 @@
 
 		dcAntispam::delAllSpam($core,$ts);
-
-		dcPage::addSuccessNotice(__('Spam comments have been successfully deleted.'));
-		http::redirect($p_url);
+		http::redirect($p_url.'&del=1');
 	}
 
@@ -91,7 +89,5 @@
 
 		dcAntispam::$filters->saveFilterOpts($filters_opt);
-
-		dcPage::addSuccessNotice(__('Filters configuration has been successfully saved.'));
-		http::redirect($p_url);
+		http::redirect($p_url.'&upd=1');
 	}
 }
@@ -132,6 +128,5 @@
 			$page_name => $p_url,
 			sprintf(__('%s filter configuration'),$filter->name) => ''
-		)).
-		dcPage::notices();
+		));
 
 	echo '<p><a href="plugin.php?p=antispam" class="back">'.__('Back to filters list').'</a></p>';
@@ -145,6 +140,5 @@
 			__('Plugins') => '',
 			$page_name => ''
-		)).
-		dcPage::notices();
+		));
 
 	# Information
@@ -156,4 +150,8 @@
 	'<form action="'.$p_url.'" method="post" class="fieldset">'.
 	'<h3>'.__('Information').'</h3>';
+
+	if (!empty($_GET['del'])) {
+		dcPage::success(__('Spam comments have been successfully deleted.'));
+	}
 
 	echo
Index: plugins/attachments/_define.php
===================================================================
--- plugins/attachments/_define.php	(revision 2257)
+++ plugins/attachments/_define.php	(revision 1179)
@@ -19,6 +19,5 @@
 	array(
 		'permissions' =>	'usage,contentadmin,pages',
-		'priority' =>		999,
-		'type'		=>		'plugin'
+		'priority' =>		999
 	)
 );
Index: plugins/blogroll/_define.php
===================================================================
--- plugins/blogroll/_define.php	(revision 2257)
+++ plugins/blogroll/_define.php	(revision 1179)
@@ -18,6 +18,5 @@
 	/* Version */			'1.3.1',
 	array(
-		'permissions' =>	'blogroll',
-		'type'		=>		'plugin'
+		'permissions' =>	'blogroll'
 	)
 );
Index: plugins/blogroll/edit.php
===================================================================
--- plugins/blogroll/edit.php	(revision 2256)
+++ plugins/blogroll/edit.php	(revision 2166)
@@ -68,6 +68,5 @@
 	try {
 		$blogroll->updateLink($id,$link_title,$link_href,$link_desc,$link_lang,trim($link_xfn));
-		dcPage::addSuccessNotice(__('Link has been successfully updated'));
-		http::redirect($p_url.'&edit=1&id='.$id);
+		http::redirect($p_url.'&edit=1&id='.$id.'&upd=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -83,6 +82,5 @@
 	try {
 		$blogroll->updateCategory($id,$link_desc);
-		dcPage::addSuccessNotice(__('Category has been successfully updated'));
-		http::redirect($p_url.'&edit=1&id='.$id);
+		http::redirect($p_url.'&edit=1&id='.$id.'&upd=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -102,6 +100,5 @@
 			html::escapeHTML($core->blog->name) => '',
 			__('Blogroll') => $p_url
-		)).
-		dcPage::notices();
+		));
 ?>
 
@@ -111,4 +108,8 @@
 if (isset($rs) && $rs->is_cat)
 {
+	if (!empty($_GET['upd'])) {
+		dcPage::success(__('Category has been successfully updated'));
+	}
+	
 	echo
 	'<form action="'.$p_url.'" method="post">'.
@@ -126,5 +127,8 @@
 if (isset($rs) && !$rs->is_cat)
 {
-
+	if (!empty($_GET['upd'])) {
+		dcPage::success(__('Link has been successfully updated'));
+	}
+	
 	echo
 	'<form action="plugin.php" method="post" class="two-cols fieldset">'.
Index: plugins/blogroll/index.php
===================================================================
--- plugins/blogroll/index.php	(revision 2256)
+++ plugins/blogroll/index.php	(revision 2208)
@@ -69,7 +69,5 @@
 		}
 	}
-	
-	dcPage::addSuccessNotice(__('links have been successfully imported.'));
-	http::redirect($p_url);	
+	http::redirect($p_url.'&importlinks=1');	
 }
 
@@ -89,7 +87,5 @@
 	try {
 		$blogroll->addLink($link_title,$link_href,$link_desc,$link_lang);
-
-		dcPage::addSuccessNotice(__('Link has been successfully created.'));
-		http::redirect($p_url);
+		http::redirect($p_url.'&addlink=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -105,6 +101,5 @@
 	try {
 		$blogroll->addCategory($cat_title);
-		dcPage::addSuccessNotice(__('category has been successfully created.'));
-		http::redirect($p_url);
+		http::redirect($p_url.'&addcat=1');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -126,6 +121,5 @@
 	
 	if (!$core->error->flag()) {
-		dcPage::addSuccessNotice(__('Items have been successfully removed.'));
-		http::redirect($p_url);
+		http::redirect($p_url.'&removed=1');
 	}
 }
@@ -154,6 +148,5 @@
 	
 	if (!$core->error->flag()) {
-		dcPage::addSuccessNotice(__('Items order has been successfully updated'));
-		http::redirect($p_url);
+		http::redirect($p_url.'&neworder=1');
 	}
 }
@@ -189,6 +182,27 @@
 			html::escapeHTML($core->blog->name) => '',
 			__('Blogroll') => ''
-		)).
-		dcPage::notices();
+		));
+?>
+
+<?php
+if (!empty($_GET['neworder'])) {
+	dcPage::success(__('Items order has been successfully updated'));
+}
+
+if (!empty($_GET['removed'])) {
+	dcPage::success(__('Items have been successfully removed.'));
+}
+
+if (!empty($_GET['addlink'])) {
+	dcPage::success(__('Link has been successfully created.'));
+}
+
+if (!empty($_GET['addcat'])) {
+	dcPage::success(__('category has been successfully created.'));
+}
+
+if (!empty($_GET['importlinks'])) {
+	dcPage::success(__('links have been successfully imported.'));
+}
 ?>
 
Index: plugins/blowupConfig/_define.php
===================================================================
--- plugins/blowupConfig/_define.php	(revision 2257)
+++ plugins/blowupConfig/_define.php	(revision 1179)
@@ -18,6 +18,5 @@
 	/* Version */			'1.2',
 	array(
-		'permissions' =>	'admin',
-		'type'		=>		'plugin'
+		'permissions' =>	'admin'
 	)
 );
Index: plugins/blowupConfig/index.php
===================================================================
--- plugins/blowupConfig/index.php	(revision 2256)
+++ plugins/blowupConfig/index.php	(revision 2166)
@@ -199,7 +199,6 @@
 		$core->blog->settings->themes->put('blowup_style',serialize($blowup_user));
 		$core->blog->triggerBlog();
-		
-		dcPage::addSuccessNotice(__('Theme configuration has been successfully updated.'));
-		http::redirect($p_url);
+
+		http::redirect($p_url.'&upd=1');
 	}
 	catch (Exception $e)
@@ -233,5 +232,5 @@
 		__('Blog appearance') => 'blog_theme.php',
 		__('Blowup configuration') => ''
-	)).dcPage::notices();
+	));
 
 echo
@@ -242,4 +241,8 @@
 	dcPage::message(__('For the following reasons, images cannot be created. You won\'t be able to change some background properties.').
 		$notices,false,true);
+}
+
+if (!empty($_GET['upd'])) {
+	dcPage::success(__('Theme configuration has been successfully updated.'));
 }
 
Index: plugins/dclegacy/_define.php
===================================================================
--- plugins/dclegacy/_define.php	(revision 2257)
+++ plugins/dclegacy/_define.php	(revision 1806)
@@ -18,6 +18,5 @@
 	/* Version */			'1.0',
 	array(
-		'priority' =>		500,
-		'type'		=>		'plugin'
+		'priority' =>		500
 	)
 );
Index: plugins/fairTrackbacks/_define.php
===================================================================
--- plugins/fairTrackbacks/_define.php	(revision 2257)
+++ plugins/fairTrackbacks/_define.php	(revision 1179)
@@ -19,6 +19,5 @@
 	array(
 		'permissions' =>	'usage,contentadmin',
-		'priority' =>		200,
-		'type'		=>		'plugin'
+		'priority' =>		200
 	)
 );
Index: plugins/importExport/_define.php
===================================================================
--- plugins/importExport/_define.php	(revision 2257)
+++ plugins/importExport/_define.php	(revision 967)
@@ -17,8 +17,5 @@
 	/* Author */			"Olivier Meunier & Contributors",
 	/* Version */			'3.2',
-	array(
-		'permissions' =>	'admin',
-		'type'		=>		'plugin'
-	)
+	/* Perm */			'admin'
 );
 ?>
Index: plugins/importExport/index.php
===================================================================
--- plugins/importExport/index.php	(revision 2256)
+++ plugins/importExport/index.php	(revision 2166)
@@ -79,6 +79,5 @@
 			$title => $p_url,
 			html::escapeHTML($module->name) => ''
-		)).
-		dcPage::notices();
+		));
 
 	echo
@@ -94,6 +93,5 @@
 			__('Plugins') => '',
 			$title => ''
-		)).
-		dcPage::notices();
+		));
 
 	echo '<h3>'.__('Import').'</h3>'.listImportExportModules($core,$modules['import']);
@@ -104,5 +102,5 @@
 '<p class="info">'.sprintf(
 	__('Export functions are in the page %s.'),
-	'<a href="plugin.php?p=maintenance&amp;tab=backup#backup">'.__('Maintenance').'</a>'
+	'<a href="plugin.php?p=maintenance&tab=backup#backup">'.__('Maintenance').'</a>'
 ).'</p>';
 
Index: plugins/maintenance/_admin.php
===================================================================
--- plugins/maintenance/_admin.php	(revision 2177)
+++ plugins/maintenance/_admin.php	(revision 2196)
@@ -29,4 +29,5 @@
 $core->addBehavior('adminAfterDashboardOptionsUpdate',	array('dcMaintenanceAdmin',	'adminAfterDashboardOptionsUpdate'));
 $core->addBehavior('adminPageHelpBlock',	array('dcMaintenanceAdmin',	'adminPageHelpBlock'));
+$core->addBehavior('pluginsToolsHeaders',	array('dcMaintenanceAdmin',	'pluginsToolsHeaders'));
 
 /**
@@ -223,5 +224,4 @@
 		$core->auth->user_prefs->maintenance->put('dashboard_item', !empty($_POST['maintenance_dashboard_item']), 'boolean');
 	}
-
 
 	/**
@@ -294,3 +294,17 @@
 		}
 	}
+
+	/**
+	 * Add javascript for plugin configuration.
+	 *
+	 * @param	$core	<b>dcCore</b>	dcCore instance
+	 * @param	$module	<b>mixed</b>	Module ID or false if none
+	 * @return	<b>string</b>	Header code for js inclusion
+	 */
+	public static function pluginsToolsHeaders($core, $module)
+	{
+		if ($module == 'maintenance') {
+			return dcPage::jsLoad('index.php?pf=maintenance/js/settings.js');
+		}
+	}
 }
